<?php

/**
 * inf_ven_consol_cliente actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_ven_consol_clienteActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }

            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (

Select 

distinct 2 as Orden, 
null as id_punto_venta,
null as abreviatura,
null as factura,
null as fecha,
null as vence,
null as estado_d,
null as estado,
null as nit,
sum(valor_factura) as valor_factura,
sum(iva) as iva,
sum(total) as total,
id_mae_ter,
'TOTAL CLIENTE: ' || nombre  As nombre
FROM( 

select tab0.*

from(

select

tab1.id_mae_ter ID_MAE_TER,
tab1.id_punto_venta ID_PUNTO_VENTA,
tab2.abreviatura AS ABREVIATURA,
tab1.sec_factura AS FACTURA,
tab1.fecha_facturacion AS FECHA,
tab1.fecha_facturacion AS VENCE,
decode(tab1.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1

UNION

select
tab4.id_mae_ter ID_MAE_TER,
tab4.id_punto_venta ID_PUNTO_VENTA,
tab5.abreviatura AS ABREVIATURA,
tab4.sec_debito AS FACTURA,
tab4.fecha_proceso AS FECHA,
tab7.fecha_vence AS VENCE,
decode(tab4.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1

)tab0
where To_Char(tab0.fecha, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin'
$whereTercero
$wherePuntoVenta
            
)  
Group By id_mae_ter,nombre

union 

Select 
1 as Orden, 
tab0.id_punto_venta as id_punto_venta,
tab0.abreviatura as abreviatura,
tab0.factura as factura,
tab0.fecha as fecha,
tab0.vence as vence,
tab0.estado_d as estado_d,
tab0.estado as estado,
tab0.nit as nit,
tab0.valor_factura as valor_factura,
tab0.iva as iva,
tab0.total as total,
tab0.id_mae_ter AS id_mae_ter,
tab0.nombre as nombre

from(

select

tab1.id_mae_ter ID_MAE_TER,
tab1.id_punto_venta ID_PUNTO_VENTA,
tab2.abreviatura AS ABREVIATURA,
tab1.sec_factura AS FACTURA,
tab1.fecha_facturacion AS FECHA,
tab1.fecha_facturacion AS VENCE,
decode(tab1.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1

UNION

select
tab4.id_mae_ter ID_MAE_TER,
tab4.id_punto_venta ID_PUNTO_VENTA,
tab5.abreviatura AS ABREVIATURA,
tab4.sec_debito AS FACTURA,
tab4.fecha_proceso AS FECHA,
tab7.fecha_vence AS VENCE,
decode(tab4.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1

)tab0

where To_Char(tab0.fecha, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin'
$whereTercero
$wherePuntoVenta
    
order by nit,abreviatura,factura

)
)

EOD;




            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];





            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (


Select * From (


Select 

distinct 2 as Orden, 
null as id_punto_venta,
null as abreviatura,
null as factura,
null as fecha,
null as vence,
null as estado_d,
null as estado,
null as nit,
sum(valor_factura) as valor_factura,
sum(iva) as valor_iva,
sum(total) as total,
id_mae_ter,
'TOTAL CLIENTE: ' || nombre  As nombre
FROM( 

select tab0.*

from(

select

tab1.id_mae_ter ID_MAE_TER,
tab1.id_punto_venta ID_PUNTO_VENTA,
tab2.abreviatura AS ABREVIATURA,
tab1.sec_factura AS FACTURA,
tab1.fecha_facturacion AS FECHA,
tab1.fecha_facturacion AS VENCE,
decode(tab1.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
case when tab1.estado=1 then tab1.valor_bruto else 0 end AS VALOR_FACTURA,
case when tab1.estado=1 then tab1.valor_iva else 0 end AS IVA,
case when tab1.estado=1 then tab1.valor_total else 0 end AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1

UNION

select
tab4.id_mae_ter ID_MAE_TER,
tab4.id_punto_venta ID_PUNTO_VENTA,
tab5.abreviatura AS ABREVIATURA,
tab4.sec_debito AS FACTURA,
tab4.fecha_proceso AS FECHA,
tab7.fecha_vence AS VENCE,
decode(tab4.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
case when tab4.estado=1 then tab4.valor_bruto else 0 end AS VALOR_FACTURA,
case when tab4.estado=1 then tab4.valor_iva else 0 end AS valor_IVA,
case when tab4.estado=1 then tab4.valor_total else 0 end AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1

)tab0
where To_Char(tab0.fecha, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin'
$whereTercero
$wherePuntoVenta
            
)  
Group By id_mae_ter,nombre

union 

Select 
1 as Orden, 
tab0.id_punto_venta as id_punto_venta,
tab0.abreviatura as abreviatura,
tab0.factura as factura,
tab0.fecha as fecha,
tab0.vence as vence,
tab0.estado_d as estado_d,
tab0.estado as estado,
tab0.nit as nit,
tab0.valor_factura as valor_factura,
tab0.iva as iva,
tab0.total as total,
tab0.id_mae_ter AS id_mae_ter,
tab0.nombre as nombre

from(

select

tab1.id_mae_ter ID_MAE_TER,
tab1.id_punto_venta ID_PUNTO_VENTA,
tab2.abreviatura AS ABREVIATURA,
tab1.sec_factura AS FACTURA,
tab1.fecha_facturacion AS FECHA,
tab1.fecha_facturacion AS VENCE,
decode(tab1.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1

UNION

select
tab4.id_mae_ter ID_MAE_TER,
tab4.id_punto_venta ID_PUNTO_VENTA,
tab5.abreviatura AS ABREVIATURA,
tab4.sec_debito AS FACTURA,
tab4.fecha_proceso AS FECHA,
tab7.fecha_vence AS VENCE,
decode(tab4.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1

)tab0

where To_Char(tab0.fecha, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin'
$whereTercero
$wherePuntoVenta
    

)   order by id_mae_ter,orden      
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;



            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }

            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT 
    
count(*) as abreviatura, 
'TOTALES' as factura,

SUM(NVL(valor_factura,0)) as valor_factura, 
SUM(NVL(iva,0)) as valor_iva, 
SUM(NVL(total,0)) as total

FROM (


Select 
1 as Orden, 
tab0.id_punto_venta as id_punto_venta,
tab0.abreviatura as abreviatura,
tab0.factura as factura,
tab0.fecha as fecha,
tab0.vence as vence,
tab0.estado_d as estado_d,
tab0.estado as estado,
tab0.nit as nit,
tab0.valor_factura as valor_factura,
tab0.iva as iva,
tab0.total as total,
tab0.id_mae_ter AS id_mae_ter,
tab0.nombre as nombre

from(

select

tab1.id_mae_ter ID_MAE_TER,
tab1.id_punto_venta ID_PUNTO_VENTA,
tab2.abreviatura AS ABREVIATURA,
tab1.sec_factura AS FACTURA,
tab1.fecha_facturacion AS FECHA,
tab1.fecha_facturacion AS VENCE,
decode(tab1.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
tab1.valor_bruto AS VALOR_FACTURA,
tab1.valor_iva AS IVA,
tab1.valor_total AS TOTAL


from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter

where tab2.es_pos=1

UNION

select
tab4.id_mae_ter ID_MAE_TER,
tab4.id_punto_venta ID_PUNTO_VENTA,
tab5.abreviatura AS ABREVIATURA,
tab4.sec_debito AS FACTURA,
tab4.fecha_proceso AS FECHA,
tab7.fecha_vence AS VENCE,
decode(tab4.estado,1,'Activa',0,'Anulada') AS ESTADO_D,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
tab4.valor_bruto AS VALOR_FACTURA,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1

)tab0

where To_Char(tab0.fecha, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin'
and tab0.estado = 1
$whereTercero
$wherePuntoVenta
    
)
EOD;


            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
